<script setup>
import {useRoute} from "vue-router"
import {computed, ref, watch} from "vue"
import {useRoomStore} from "@/stores/room"
import Sidebar from "@/components/Sidebar.vue"
import {router} from "@/router";

const route = useRoute()
const roomStore = useRoomStore()
const roomIndex = computed(() => parseInt(route.params.roomIndex))
const roomget = computed(() => roomStore.rooms[roomIndex.value])

const roomNumber = ref("")
const vip = ref("")
const descriptionRoom = ref("")
const edit = ref(false)

const room = ref()
const apiError = ref("")

watch(roomget, () => room.value = ({...roomget.value} || {roomName: "sgd"}), {immediate: true})

async function deleteRoom() {
  const response = await useRoomStore().deleteRoom(room.value);

  await router.push("/room")
  console.log("test");
}

async function updateRoom() {

  apiError.value = ""

  try {
    await roomStore.updateRoom(room.value)

  } catch (err) {
    if (err.isAxiosError && err.status === 401) {
      apiError.value = "You must be logged in"
    } else {
      apiError.value = "Unknown error"
    }
  }
  await router.push("/room")
}

roomNumber.value = ""
vip.value = ""
descriptionRoom.value = ""

</script>

<template>
  <Sidebar></Sidebar>

  <h1>Details for Rooms</h1>

  <div class="container text-white rounded-2 p-3 mb-3">
    <p>Number: <span v-if="!edit">{{ room.roomNumber }}</span> <input v-else class="form-control" type="text"
                                                                      v-model="room.roomNumber"/></p>
    <p>Person Name: <span v-if="!edit"> {{ room.vip }}</span> <input v-else class="form-control" type="text"
                                                                     v-model="room.vip"/></p>
    <p>Description: <span v-if="!edit"> {{ room.descriptionRoom }}</span> <input v-else class="form-control" type="text"
                                                                                 v-model="room.descriptionRoom"/></p>
  </div>
  <div class="buttons">
    <v-btn type="submit" class="btn btn-warning mx-2" @click="edit = !edit" v-if="!edit">Edit</v-btn>
    <v-btn type="submit" class="btn btn-warning mx-2" @click="updateRoom" v-else>Save</v-btn>
    <v-btn type="submit" class="btn btn-danger" @click="deleteRoom">Delete</v-btn>
  </div>


</template>


<style scoped>
h1 {
  margin-left: 0px;
  margin-bottom: 20px;
  margin-top: 0px;
}

p {
  margin-left: 0px;
}

.form-check {
  margin-left: 0px;
}

.container {
  background-color: black;
  width: 1000px;
}

.buttons {
  margin-left: 0px;
  margin-top: 15px;
  margin-bottom: 20px;

}
</style>